summaryrefslogtreecommitdiff
path: root/.local
diff options
context:
space:
mode:
Diffstat (limited to '.local')
-rwxr-xr-x.local/bin/config-path51
-rwxr-xr-x.local/bin/config-symlinks15
-rwxr-xr-x.local/bin/notifyd14
-rwxr-xr-x.local/bin/pick38
-rwxr-xr-x.local/bin/x-pdf9
-rwxr-xr-x.local/bin/x-terminal-emulator12
-rwxr-xr-x.local/bin/x-www-browser14
-rw-r--r--.local/lib/path.sh9
-rw-r--r--.local/lib/xdg.sh23
9 files changed, 143 insertions, 42 deletions
diff --git a/.local/bin/config-path b/.local/bin/config-path
new file mode 100755
index 0000000..6b9019c
--- /dev/null
+++ b/.local/bin/config-path
@@ -0,0 +1,51 @@
+#!/bin/bash
+
+# All the prefixes to consider
+prefixes=(
+ "$HOME"
+ "$HOME/.local.`uname -m`"
+ "$HOME/.local"
+ "$HOME/.prefix.`uname -m`"
+ "$HOME/.prefix"
+ "$HOME"/.gem/ruby/*
+)
+
+######################################################################
+
+in_array() {
+ local needle=$1; shift
+ local haystack=("$@")
+ local straw
+ for straw in "${haystack[@]}"; do
+ [[ "$needle" == "$straw" ]] && return 0
+ done
+ return 1
+}
+
+# Import existing values
+IFS=: paths=($PATH)
+IFS=: rubylibs=($RUBYLIB)
+
+# Scan through prefixes
+for prefix in "${prefixes[@]}"; do
+ # PATH
+ dir="$prefix/bin"
+ if [[ -d "$dir" ]] && ! in_array "$dir" "${paths[@]}"; then
+ paths=("$dir" "${paths[@]}")
+ fi
+ # RUBYLIB
+ dir="$prefix/lib"
+ if [[ -d "$dir" ]] && ! in_array "$dir" "${rubylibs[@]}"; then
+ rubylibs=("$dir" "${rubylibs[@]}")
+ fi
+done
+
+# Finally, print our values
+IFS=: PATH="${paths[*]}"
+IFS=: RUBYLIB="${rubylibs[*]}"
+
+# The sed bit here is the only time we call an external program
+{
+ declare -p PATH
+ declare -p RUBYLIB
+} | sed 's/^declare \(-\S* \)*//'
diff --git a/.local/bin/config-symlinks b/.local/bin/config-symlinks
new file mode 100755
index 0000000..0831ca3
--- /dev/null
+++ b/.local/bin/config-symlinks
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+sed -e '/^\s*$/d' -e '/#/d' symlinks | while read _target _link; do
+ target="$(sed -rn 's|[^/]+/|../|g;s|/[^/]+$|/|p' <<<"$_link")${_target}"
+ link="$HOME/$_link"
+ if [[ -L "$link" ]]; then
+ rm -f "$link"
+ fi
+ if [[ -e "$link" ]]; then
+ echo "ERROR: file exists: $link" >> /dev/stderr
+ else
+ mkdir -p "${link%/*}"
+ ln -s "$target" "$link"
+ fi
+done
diff --git a/.local/bin/notifyd b/.local/bin/notifyd
deleted file mode 100755
index ddd5971..0000000
--- a/.local/bin/notifyd
+++ /dev/null
@@ -1,14 +0,0 @@
-#!/bin/bash
-
-connected_to_x_server() {
- xdpyinfo &>/dev/null
- return $?
-}
-
-start_backend() {
- /usr/lib/xfce4/notifyd/xfce4-notifyd
-}
-
-while connected_to_x_server; do
- start_backend
-done
diff --git a/.local/bin/pick b/.local/bin/pick
new file mode 100755
index 0000000..ed2d44d
--- /dev/null
+++ b/.local/bin/pick
@@ -0,0 +1,38 @@
+#!/bin/bash
+
+cmd=${0##*/}
+
+if [[ $1 = -h ]]; then
+ echo "Usage: $cmd PROG1 PROG2 PROG3..."
+ echo " $cmd -s PROG1 PROG2 PROG3..."
+ echo ""
+ echo "If \`-s' ISN'T given, print the first program name given that is"
+ echo "found in PATH."
+ echo ""
+ echo "If \`-s' IS given, print the first program name given that is"
+ echo "currently running. If no match is found, fall back to default"
+ echo "behavior."
+ exit 0
+fi
+
+if [[ $1 = -s ]]; then
+ shift
+ # Scan to find a running instance
+ for prog in "$@"; do
+ if [[ -n "`pgrep $prog`" ]]; then
+ printf '%s\n' "$prog"
+ exit 0
+ fi
+ done
+fi
+
+# Scan to find one that is installed
+for prog in "$@"; do
+ if [[ -x "`which $prog 2>/dev/null`" ]]; then
+ printf '%s\n' "$prog"
+ exit 0
+ fi
+done
+
+printf '%s\n' "$cmd: no suitable program found"
+exit 1
diff --git a/.local/bin/x-pdf b/.local/bin/x-pdf
index a9893c0..1b23a3d 100755
--- a/.local/bin/x-pdf
+++ b/.local/bin/x-pdf
@@ -1,9 +1,4 @@
#!/bin/sh
-if [ -x "`which okular 2>/dev/null`" ]; then
- okular "$@"
-elif [ -x "`which evince 2>/dev/null`" ]; then
- evince "$@"
-elif [ -x "`which xpdf 2>/dev/null`" ]; then
- xpdf "$@"
-fi
+`pick evince okular xpdf` "$@"
+exit $?
diff --git a/.local/bin/x-terminal-emulator b/.local/bin/x-terminal-emulator
index f7290b4..049b081 100755
--- a/.local/bin/x-terminal-emulator
+++ b/.local/bin/x-terminal-emulator
@@ -1,10 +1,4 @@
#!/bin/sh
-if [ -x "`which emacsterm`" ]; then
- emacsterm $@
-elif [ -x "`which urxvt`" ]; then
- urxvt $@
-elif [ -x "`which gnome-terminal`" ]; then
- gnome-terminal $@
-elif [ -x "`which xterm`"]; then
- xterm $@
-fi
+
+`pick emacsterm urxvt gnome-terminal xterm` "$@"
+exit $?
diff --git a/.local/bin/x-www-browser b/.local/bin/x-www-browser
index 0ead72a..bbd8943 100755
--- a/.local/bin/x-www-browser
+++ b/.local/bin/x-www-browser
@@ -1,14 +1,4 @@
#!/bin/sh
-list='firefox iceweasel icecat conkeror'
-
-looking=true
-for prog in $list; do
- if $looking && [ -n "`pgrep $prog`" ]; then
- $prog $@
- looking=false
- fi
-done
-if $looking; then
- conkeror $@
-fi
+`pick -s conkeror iceweasel icecat firefox` "$@"
+exit $?
diff --git a/.local/lib/path.sh b/.local/lib/path.sh
new file mode 100644
index 0000000..a45f8fd
--- /dev/null
+++ b/.local/lib/path.sh
@@ -0,0 +1,9 @@
+#!/bin/sh
+
+if type config-path &>/dev/null; then
+ config_path=config-path
+else
+ # Bootstrap finding config-path
+ config_path="$HOME/.local/bin/config-path"
+fi
+eval "$("$config_path" | sed 's/^/export /')"
diff --git a/.local/lib/xdg.sh b/.local/lib/xdg.sh
new file mode 100644
index 0000000..2241d2e
--- /dev/null
+++ b/.local/lib/xdg.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+# This should be readable by /bin/sh, but I'm going to assume bash.
+
+# Sets up XDG environmental variables, so programs using them don't have to
+# worry about checking if they are set.
+# http://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html
+
+[[ -n $XDG_DATA_HOME ]] || export XDG_DATA_HOME="$HOME/.local/share"
+[[ -n $XDG_CONFIG_HOME ]] || export XDG_CONFIG_HOME="$HOME/.config"
+[[ -n $XDG_DATA_DIRS ]] || export XDG_DATA_DIRS="/usr/local/share/:/usr/share/"
+[[ -n $XDG_CONFIG_DIRS ]] || export XDG_CONFIG_DIRS="/etc/xdg"
+[[ -n $XDG_CACHE_HOME ]] || export XDG_CACHE_HOME="$HOME/.cache"
+
+# Check if XDG_RUNTIME_DIR is set, but has a bogus setting
+if [[ -n $XDG_RUNTIME_DIR ]] && [[ ! -d $XDG_RUNTIME_DIR ]]; then
+ unset XDG_RUNTIME_DIR
+fi
+
+# Set XDG_RUNTIME_DIR if we can
+if [[ -z $XDG_RUNTIME_DIR ]] && [[ -n $TMPDIR ]]; then
+ export XDG_RUNTIME_DIR="$TMPDIR/xdg-runtime"
+ install -dm0700 "$XDG_RUNTIME_DIR"
+fi